-------------------------------------------------------------------------------
-- MrCurrency
--
-- Data Broker source for Currency
--
-- Send suggestions, comments, and bugs to user@zedonline.net
-------------------------------------------------------------------------------

MRCUtils = {};

function MRCUtils:AppendCurrency(text,amount,icon,displayZero)
	if(amount == nil) then amount = 0 end;
	if(displayZero == nil) then displayZero = false end;
	
	if( amount > 0 or displayZero ) then
		if( text ~= "" ) then text = text .. " " end;
--		text = text .. amount .. " |T" .. icon .. ":0|t";
		text = text .. amount .. " |T" .. icon .. ":24:24:0:0:64:64:4:60:4:60|t";
	end
	
	return text;
end

function MRCUtils:GetMoneySplit(money)
	local gold, silver, copper;
	
	if(money == nil) then
		money = GetMoney();
	end
	
	copper = floor(money % 100);
	money = floor(money / 100);
	silver = money % 100;
	money = floor(money / 100);
	gold = money;
	
	return gold, silver, copper;
end

function MRCUtils:TablePairPack(...)
	local t,k,v;
	t = {};
	for i = 1, select("#", ...), 2 do
		k = select(i, ...);
		v = select(i+1, ...) or 0;
		tinsert(t, k);
		tinsert(t, v);
	end
	return t;
end

function MRCUtils:TablePack(...)
    local t,v;
    t = {};
    for i = 1, select("#", ...) do
        v = select(i, ...);
		if(v ~= nil) then
        	tinsert(t, v);
		end
    end
    return t;
end

function MRCUtils:TableSize(table)
	local count = 0;

	for _, _ in pairs(table) do
		count = count + 1;
	end
	
	return count;
end

function MRCUtils:TableJoin(t1, t2)
    for k,v in pairs(t2) do
		t1[k] = v;
	end 
	return t1;  
end