-------------------------------------------------------------------------------
-- MrCurrency
--
-- Data Broker source for Currency
--
-- Send suggestions, comments, and bugs to user@zedonline.net
-------------------------------------------------------------------------------

MrCurrency = LibStub("AceAddon-3.0"):NewAddon("MrCurrency",
											  "AceEvent-3.0");								
local UPDATEPERIOD = 1.0;
					
function MrCurrency:OnInitialize()
	-- Some initialization
	self.elapsed = 0;
	
	local LDB = LibStub("LibDataBroker-1.1", true);
	if LDB then
		--self.frame = CreateFrame("frame");
		--self.broker = CreateFrame("Frame", "MrTraderMenu", UIParent, "UIDropDownMenuTemplate");
		--UIDropDownMenu_SetWidth(self.dropdown, 140);
	
		self.dataSource = LDB:NewDataObject("MrCurrency", {
	    	type = "data source",
			text = "Loading...",
			label = "MrCurrency",
	    	OnClick = function(clickedframe, button)
	        	-- Do something interesting here
	    	end,
			OnTooltipShow = function(tip)
				-- Do something else interesting here
			end,
		});
		
		self:RegisterEvent("PLAYER_MONEY", "OnUpdate");
		self:RegisterEvent("CURRENCY_DISPLAY_UPDATE", "OnUpdate");
		self:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE", "OnUpdate");
		--self.frame:SetScript("OnUpdate", function(self, elap) MrCurrency:OnUpdate(elap) end);
	end
end

function MrCurrency:OnUpdate()
	self:GenerateText();
end

-- TODO: Address some of the "expensiveness" of this method
function MrCurrency:GenerateText()
	local gold, silver, copper = MRCUtils:GetMoneySplit();
	local text = "";

	text = MRCUtils:AppendCurrency(text, gold, "Interface\\MoneyFrame\\UI-GoldIcon");
	text = MRCUtils:AppendCurrency(text, silver, "Interface\\MoneyFrame\\UI-SilverIcon");
	text = MRCUtils:AppendCurrency(text, copper, "Interface\\MoneyFrame\\UI-CopperIcon");
	
	-- Expand all Items
	local expanding = true;
	local expandedItems = {};
	while expanding do
		expanding = false;
		for index=1,GetCurrencyListSize() do
			name, isHeader, isExpanded, isUnused, isWatched, count, icon, version = GetCurrencyListInfo(index);
		
			if( isHeader and not isExpanded ) then
				ExpandCurrencyList(index, 1);
				tinsert(expandedItems, 1, index);
				expanding = true;
			end
		end
	end
	
	-- Process
	for index=1,GetCurrencyListSize() do
		name, isHeader, isExpanded, isUnused, isWatched, count, icon, version = GetCurrencyListInfo(index);

		if( name and not isHeader and not isUnused ) then
			text = MRCUtils:AppendCurrency(text, count, icon);
		end	
	end
	
	-- Recollapse
	for _,item in ipairs(expandedItems) do
		ExpandCurrencyList(item, 0);
	end
	
	self.dataSource.text = text;
end